/******************************************************************************/
/* The information contained in this file is confidential and proprietary to  */
/* Broadcom Corporation.  No part of this file may be reproduced or           */
/* distributed, in any form or by any means for any purpose, without the      */
/* express written permission of Broadcom Corporation.                        */
/*                                                                            */
/* (c) COPYRIGHT 2002 Broadcom Corporation, ALL RIGHTS RESERVED.              */
/*                                                                            *
 ******************************************************************************/

#ifndef sromutl_H
#define sromutl_H

#define OPTS			"b:w:cCdDh:v"
#include "sbsprom.h"
#include "Cl4xsb.h"
/* Action to take */
#define	CHECK_CRC		1
#define	FIX_CRC			2
#define	JUST_DUMP		3
#define	PROGRAM_HW		4
#define	PROGRAM_REST	5
#define PROGRAM_WORD    6
#define OUTPUT_2_BIN    7
#define BOOTROM		    8

#define CLASS_ETHER	0x0000
#define CLASS_NET	0x0002
#define PME_4402_ENET	0
#define PMEREP_4402_ENET	(PMERD3CV | PMERD3CA | PMERD3H | PMERD2 | PMERD1 | PMERD0 | PME)
#define SRFN_B1PMER	4
#define B1E		1
#define B1SZMSK	0xe
#define B1SZSH		1
#define PMERMSK	0x0ff0
#define PME		0x0010
#define PMERD0		0x0020
#define PMERD1		0x0040
#define PMERD2		0x0080
#define PMERD3H	0x0100
#define PMERD3CA	0x0200
#define PMERD3CV	0x0400
#define IGNCLKRR	0x0800
#define B0LMSK		0xf000


/* Device descriptors */

typedef struct {
	int		bus;		/* Bus number */
	int		slot;		/* (Virtual) slot number */
	int		fun;		/* Function number for multifunction devices */
	//unsigned long	barsz[100]; /* Size of the bar spaces */
	unsigned long	romsz;		/* Size of the rom bar space */
	unsigned long	wa4710addr;	/* 4710 workaround needed for this device? */
	int		cfgsize;	/* Size of configuration space */
	//pci_config_regs	config;		/* Copy of configuration space */
} dev_info;
/* The information in a bar, expanded for ease of use */
typedef struct {
	int		io;
	unsigned long	base;
	unsigned long	size;
	int		guess;
} bar_info;
typedef enum chip_type {
	BCM4401 = 0,
	UNKNOWN_CHIP
} chip_type_t;

typedef struct {
	uint16		device;
	uint16		classlo;
	uint16		classhi;
	uint16		pmesrc;
	uint16		pmerep;
	uint16		bar1sz;
} fn_info_t;

/* each device has MAX_FN entries */



typedef struct {
	char *		name;
	int			req_args;
	uint16		vendor;
	uint16		device;
	uint16		alt_device;
	uint16		pi;
	uint16		funmask;
	uint16		fclk;
	uint16		cbm;
	uint16		cpwr;
	uint16		phyval;
	fn_info_t *	functions;
} chip_info_t;



/* Globals used by pci access code */
//int	do_debug = 0;
//int	verbose = 0;

//FILE	*outf;



int hexstring(char *hstr, uint16 *hex, int n, int byteswap);
void srdump(uint16 *srom, int nw, char *header, chip_type_t ChipType);
void wrhdr (uint16 *rom, chip_info_t *ci, uint16 deviceid, uint16 subvendor, uint16 subdevice, uint16 brsize);
void wrfun (uint16 *rom, uint fn, fn_info_t *finfo) ;


#endif /* sromutl_H */

