/*********************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: T 3 _ G D A T A  . H
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t3_gdata.h 7     7/19/02 10:07a Ahui $
 *
 *  Description: This file contains global data.
 *
 *  AUTHOR: Kevin Tran
 *
 *  HISTORY:    Kevin Tran        06/01/2000   Created
 *  $Log: /Source/Bcm44xx/b44diag/t3_gdata.h $
 * 
 * 7     7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 6     7/08/02 12:24p Ahui
 * 
 * 5     6/11/02 11:55a Ahui
 * Support fmac option.
 * 
 * 4     5/16/02 5:58p Mnima
 * use input eeprom name
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 * 
 *******************************************************************/

#ifndef __T3_GDATA_H__
#define __T3_GDATA_H__

#include <stdio.h>
#include <time.h>
#include "t3_util.h"
#include "t3_reg.h"
#include "um.h"
#include "t3_mdiag.h"
#include "t3_data.h"

#define MAX_DEVICES             16
#define MAX_BUS_SUPPORT         8
#define MAX_ONE_BUS_DEVICES     32
#define CURRCARD global.t_cards[global.current_card]
#define MAX_PRINTF_BUFFER       4096
#define MAC_ADDR_STR            13
#define MAX_FILE_NAME_SIZE      80
#define BIST_DATA_SIZE          2184
#define EEPROM_FILENAME         "eeprom.bin"
#define GENEEP_FILENAME         "eeprom.txt"
#define REF_FILENAME            "refinfo.txt"
#define BIST_FILE_DATA_IN       "bist5703.in"
#define BIST_FILE_DATA_EX       "bist5703.ex"

#define MAX_EOM 4

/* bit defined for verbose variable */
#define V_CONSOLE  0x1
#define V_ERROR    0x2
#define V_IO       0x4
#define V_DEBUG    0x8
#define V_PRINTER  0x10
#define V_WARNING  0x20

typedef enum {
    MANUF_INVALID, 
    MANUF_DELL,
    MANUF_3COM,
} MANUF_CUST_t;

extern s08 * manuf_cust_str[];

typedef struct {
    pRegs miiRegs;
    pRegs pciRegs;
    time_t start_time;
    T3_TEST_RECORD test_record;
    double worst_interrupt_latency;
    FILE *G_ifile;
    FILE *logfile;
    FILE *binfile;
    s08  *defLogFileName;
    s08  *defBinFileName;
    s08  *defTxtFileName;
    s08  *PxeFileName;
    card_t t_cards[MAX_DEVICES];

    u32  mem_base_addr;
    u32  rom_base_addr;
    u32  clk_scale;
    u32  system_ticks;
    u32  ExtMemSize;
    u32  devSelect;
    u32  blastCntl;
    u32  verbose; 
    u32  ref;

    int  tx_wait;
    int  progress_bar_index;
    int  radix;  
    u08  video_mode;
    u08  manuf;
    u08  device_detected;
    u08  current_card;
    u08  optUpdateWol;
    int  optWOL;
    u08  optUpdatePxe;
    int  optPXE;
    u08  optPrint;
    u08  optManufLoop;
    u08  optMacProg;
    u08  optManufCust;
    u08  use_dpmi;
    u08  test_bus;
    u08  test_dev;     
    s08  pbuf[MAX_PRINTF_BUFFER];
    u08  ChipTest;
//    u08  CmdMode;
    u08  NoCRC;
    u08  optMacCmdLine;
	u08  optBrom;
	u08  optMacFile;
    u08  optCardSelect;
    s08  mac_address[MAC_ADDR_STR];
    u08  optSkipEECheck;
    u08  Rs232;
    u32  isrDelay;
    u08  optContinueOnError;
    u32  RunTimeInHrs;
    u08  optShowRealDevice;
    u08  pollCPU;
    u08  detectAll;
    u08  VPDWrite;
    u08  noinit;
    u08  optProgPxe;
    u08  optVerifyPxe;
    u08  optNegLinkPol;
    s08 *EEpFileName;
    u32  dbg_path;
    u16  dbg_level;
    DIAG_CB diag_cb;
    s08  logFileName[MAX_FILE_NAME_SIZE];
    s08  binFileName[MAX_FILE_NAME_SIZE];
    s08  txtFileName[MAX_FILE_NAME_SIZE];
    u32  pciDev;
    u08  msec_delay;
    u08  usec_delay;
    u08  nsec_delay;
    u08  bistDataIn[BIST_DATA_SIZE];
    u08  bistDataOut[BIST_DATA_SIZE];
    u08  bistDataEx[BIST_DATA_SIZE];
	s08  MacAddrFileName[20];
    s08  mac_address_end[6];
	s08  romsize;
} globalVar;

extern globalVar global;

#define ReturnX(x,c)     {x = c; if (global.diag_cb.abort_on_fail) return c; }

#endif /* __T3_GDATA_H__ */
