/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: T 3 _ H I S T . H
 *
 *  Description: This file contains command line interface macros
 *  and data structures.
 *
 *  AUTHOR: Kevin Tran
 *
 *  HISTORY:    Kevin Tran        06/01/2000   Created
 *
 *******************************************************************/

#ifndef __T3_HIS_H__
#define __T3_HIS_H__

#define HISTORY_LINES	20
#define MAX_LINE_LENGTH	80

#ifdef EFI          /* Undef the EFI definitions */
#undef ARROW_UP
#undef ARROW_DOWN
#endif
#define ARROW_UP	0x4800
#define ARROW_DOWN	0x5000
#define ARROW_LEFT	0x4b00
#define ARROW_RIGHT	0x4d00
#define ESC		    0x011b
#define CTRL_C		0x2e03
#define CTRL_U		0x1615
#define RET		    0x1c0d
#define ERASE		0x0e08
#define DEL		    0x5300
#define CTRL_H		0x2308
#define INSERT		0x5200
#define RETURN      0xd
#define BACKSPACE   0x8

#include "types.h"
/************************************************************************
 *      Functions exported from history.c                               *
 ************************************************************************/
typedef s08 cmdLine_t[MAX_LINE_LENGTH];
typedef cmdLine_t hist_t[HISTORY_LINES];
s08 *get_line (int (*callback)(void));
void init_history ();
void cleanup_history ();
void init_break ();
void clear_break ();
int user_break ();
//void  win_gotox (int x);

#endif /* __T3_HIS_H__ */
