/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: T3 _ M D I A G . C
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t3_mdiag.c 8     7/19/02 10:07a Ahui $
 *
 *  Description: This file contains manufacturing diagnostics.
 *
 *  AUTHOR: Kevin Tran
 *
 *  HISTORY:    Kevin Tran        07/28/2000   Created
 *  $Log: /Source/Bcm44xx/b44diag/t3_mdiag.c $
 * 
 * 8     7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 7     4/25/02 11:05a Ahui
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 * 
 *******************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "general.h"
#include "t3_mdiag.h"
#include "t3_gdata.h"

/* Local function prototypes */
static void tx_tprot_packet_comp_from_mac(PUM_PACKET pPacket);


int testfail;


int setup_tprot_packet(u08 *buffer,int len, u08 tprot_type, u08 packet_format)
{
  int i;
  int data_len;
  int fill_data = 0;
  
  /* First of all, initialize MAC header */
  for (i = 0 ; i < sizeof(MAC_ADDR); i++)
    {
      *buffer++ = global.test_record.cfg.dest_mac[i];
    }

  for (i = 0 ; i < sizeof(MAC_ADDR); i++)
    {
      *buffer++ = global.test_record.cfg.src_mac[i];
    }

  *(u16 *)buffer = HOST_TO_NET16(global.test_record.cfg.type);
  buffer += 2;
  /* Magic Signature */
#if 0         /* This has an alignment problem on IA64 */
  *(u32 *)buffer = TPROT_PACKET_SIG;
  buffer += 4;
#else
  *buffer++ = (u08)(TPROT_PACKET_SIG >> 0 & 0xff);
  *buffer++ = (u08)(TPROT_PACKET_SIG >> 8 & 0xff);
  *buffer++ = (u08)(TPROT_PACKET_SIG >> 16 & 0xff);
  *buffer++ = (u08)(TPROT_PACKET_SIG >> 24 & 0xff);
#endif

  *buffer++ = tprot_type;

  switch (tprot_type)
    {
    case TPROT_PACKET_TYPE_PACKET_ACK:

      break;
        
    case TPROT_PACKET_TYPE_DATA_PACKET:
      *buffer++ = packet_format;
      data_len = len - TPROT_PACKET_OVERHEAD_SIZE;
      *((u16 *)buffer) = (u16)data_len;
      buffer += 2;
      fill_data = 1;
      break;

    case TPROT_PACKET_TYPE_LOOPBACK:

      break;

    case TPROT_PACKET_TYPE_REMOTE_ADDR:

      break;


    case TPROT_PACKET_TYPE_REMOTE_ADDR_REPLY:

      break;

    case TPROT_PACKET_TYPE_SEND_PACKETS:

      break;

    case TPROT_PACKET_TYPE_GET_STATISTICS:

      break;

    case TPROT_PACKET_TYPE_GET_STATISTICS_REPLY:

      break;

    case TPROT_PACKET_TYPE_RECEIVE_PACKETS:


      break;

    case TPROT_PACKET_TYPE_RESET_SERVER_STATS:

      break;

    case TPROT_PACKET_TYPE_LAST_ITEM:

      break;

    default:
      return -1;
      break;
    }

  if (fill_data)
    {
      for (i = 0; i < data_len ; i++)
        {
          *buffer++ = i;
        }
    }

  return 0;
}

