/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: T 3 _ M D I A G . H
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t3_mdiag.h 8     7/19/02 10:07a Ahui $
 *
 *  Description: This file contains macro and data structure definition
 *  relating to Manufacturing Diagnostics.
 *
 *  AUTHOR: Kevin Tran
 *
 *  HISTORY:    Kevin Tran        07/28/2000   Created
 *  $Log: /Source/Bcm44xx/b44diag/t3_mdiag.h $
 * 
 * 8     7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 7     4/25/02 11:05a Ahui
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 * 
 *******************************************************************/

#ifndef __T3_MDIAG_H__
#define __T3_MDIAG_H__


#include "protocol.h"

typedef struct T3_TEST_RECORD
{
  struct 
  {
    int num_tx_packet;
    MAC_ADDR dest_mac;
    MAC_ADDR src_mac;
    u16 type;
    int tx_start_len;
    int tx_len_inc;
    int frag_size;
    int tx_max_len;
    int tx_flags;
  }cfg;

  struct 
  {
    u32 tx_enq_count;
    u32 tx_count;
    u32 tx_comp_unknown_packet;
    u32 rx_count;
    u32 rx_unknown_packet;
    u32 rx_bad_packet;
    u32 rx_good_packet;
  }stats;
}T3_TEST_RECORD,*pT3_TEST_RECORD;

int setup_tprot_packet(u08 *buffer,int len, u08 tprot_type,
		       u08 packet_format);


#endif /* __T3_MDIAG_H__ */

