/********************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t3_reg.h 4     7/19/02 10:07a Ahui $
 *
 *  Description: This file contains each individual tests
 *
 *  $Log: /Source/Bcm44xx/b44diag/t3_reg.h $
 * 
 * 4     7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 *****************************************************************/

#ifndef __T3_REG_H__
#define __T3_REG_H__


#define MAX_FIELD    32


typedef enum 
{
    REG_MAC,
    REG_PCI,
    REG_MII,
    REG_IO,
    MAX_REG_TYPE,
} REG_T; 

typedef struct
{
    u32  mask;
    s08 * name;
    s08 * desc;
    u32  ptrCnt;
} Field, *pField;

typedef struct 
{
    s08 * name;
    int   width;    // 1: byte, 2: short, 4: long 
    u32  Offset;
    U32  RdMask;       // Read only register mask.
    U32  WrMask;       // Read/Write mask.
    u32  f_cnt;
    pField fields[MAX_FIELD];
} Reg, *pReg;

typedef struct 
{
    s08 * name;
    REG_T type;
    u32   r_cnt;
    pReg  regs;
} Regs, *pRegs;    


#endif
