/****************************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: T3 _ T X . C
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t3_tx.c 8     7/19/02 10:07a Ahui $
 *
 *  Description: This file contains routine to transmit protocol 
 *               packets to test out T3 protocol features.
 *
 *  AUTHOR: Kevin Tran
 *
 *  HISTORY:    Kevin Tran        06/01/2000   Created
 *  FileName: $Log: /Source/Bcm44xx/b44diag/t3_tx.c $
 * 
 * 8     7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 7     4/25/02 11:03a Ahui
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 *******************************************************************/

/** include files **/

/** include files **/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "general.h"
#include "t3_tx.h"
#include "t3_intr.h"
#include "t3_cli.h"
#include "t3_comm.h"

/**************************************************************/
/* public procedures */
/**************************************************************/

int txInitCfg(command_ptr cmd)
{
    pTX_TEST_INFO txInfo = &CURRCARD.txInfo;
    u32 temp;
    
    txInfo->num_tx_packets = pValue32(cmd,'n');
    txInfo->max_number_fragments = pValue32(cmd,'f');
    txInfo->use_random_fragments = cmd_optionEntered(cmd,'j');
    txInfo->use_random_pkt_len = cmd_optionEntered(cmd,'k');
    txInfo->min_block_size = pValue32(cmd,'z');
    if (cmd_optionEntered(cmd,'r'))
    {
        temp = pValue32(cmd,'r');
        if (temp > 3)
        {
            printf("Tx ring must be (0..3)\n");
            return HAS_ERROR;
        }
        txInfo->start_ring_num = temp;
    }
    txInfo->insert_frag_info = cmd_optionEntered(cmd,'v');
    txInfo->inc_len = cmd_optionEntered(cmd,'i');
    temp = pValue32(cmd,'l');  // default to invalid length
    txInfo->curr_tx_len = txInfo->start_tx_len =  (temp >= 14) && (temp <= TX_STD_BUFSIZE) ? temp : txInfo->total_packet_size;
    CheckValue32(cmd,'d',txInfo->tx_ipg);
    CheckValue32(cmd,'g',txInfo->flags);
    txInfo->multi_tx_ring_test = cmd_optionEntered(cmd,'m');
    CheckValue32(cmd,'p',txInfo->num_tx_ring);
    CheckValue32(cmd,'q',txInfo->packet_per_ring);
    txInfo->burst_length = pValue32(cmd,'b');
    txInfo->dont_init_data = cmd_optionEntered(cmd,'L');
    txInfo->buffer_offset = pValue32(cmd,'o');
    txInfo->ip_frag_count = pValue32(cmd,'a');
    txInfo->insert_raw_checksum = cmd_optionEntered(cmd,'e');
    txInfo->ip_total_len = pValue32(cmd,'h');
    txInfo->standard_seg = cmd_optionEntered(cmd,'u');
	txInfo->use_static_buffer = cmd_optionEntered(cmd,'A');
    if (cmd_optionEntered(cmd,'R'))
        com_enable();
    return NO_ERROR;
}



