/******************************************************************************
 * The information contained in this file is confidential and proprietary to  
 * Broadcom Corporation.  No part of this file may be reproduced or           
 * distributed, in any form or by any means for any purpose, without the      
 * express written permission of Broadcom Corporation.                        
 *                                                                            
 * (c) COPYRIGHT 2000 Broadcom Corporation, ALL RIGHTS RESERVED.              
 *                                                                            
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t3_win.c 3     3/07/02 5:05p Ahui $
 *
 * Module Description:                                                        
 *                                                                            
 *  $Log: /Source/Bcm44xx/b44diag/t3_win.c $
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 ******************************************************************************/
#include "t3_win.h"
#include "t3_util.h"
#include "t3_gdata.h"
#include "t3_comm.h"
#include <ctype.h>
#ifndef EFI
#include <malloc.h>
#include <graph.h>
#include <conio.h>
#endif
#include "t3_hist.h"

/* typedef s08 (hist_t)[HISTORY_LINES][MAX_LINE_LENGTH+1]; */
 
typedef struct
{
    pWin  wList;
//    pWin  activeWin;
    int   insertMode;
    ScreenPtr saveScrn;
    struct rccoord oldxy;
    int  histInsPos;
    int  histGetPos;
    hist_t hist;
} win_world;

s08 * winHeaderFmt = " [ALT-%c] %s ";

#define HOTKEY_POS 6
#define NAME_POS 9
#define WIN_HEADER_POS 3
#define INACTIVE_FRAME_ATTRIB ATTRIB(GRAY,BLUE)
#define ACTIVE_FRAME_ATTRIB ATTRIB(YELLOW,BLUE)

static win_world ww = {NULL,1,NULL,{0,0},0,0};
     
//************************************************************************
// private routines
//************************************************************************

static pWin selectWindow()
{
    return ww.wList;
}

static s08 hotKeyCh(u16 key)
{
    u16 digit[10] = {KEY_ALT_0,KEY_ALT_1,KEY_ALT_2,KEY_ALT_3,KEY_ALT_4,
                     KEY_ALT_5,KEY_ALT_6,KEY_ALT_7,KEY_ALT_8,KEY_ALT_9};
    U16 alpa[26] =  {KEY_ALT_A,KEY_ALT_B,KEY_ALT_C,KEY_ALT_D,KEY_ALT_E,
                     KEY_ALT_F,KEY_ALT_G,KEY_ALT_H,KEY_ALT_I,KEY_ALT_J,
                     KEY_ALT_K,KEY_ALT_L,KEY_ALT_M,KEY_ALT_N,KEY_ALT_O,
                     KEY_ALT_P,KEY_ALT_Q,KEY_ALT_R,KEY_ALT_S,KEY_ALT_T,
                     KEY_ALT_U,KEY_ALT_V,KEY_ALT_W,KEY_ALT_X,KEY_ALT_W,
                     KEY_ALT_Z};
    int i;
    for (i=0;i<10;i++)
        if (key==digit[i])
            return '0'+i;
    for (i=0;i<26;i++)
        if (key==alpa[i])
            return 'A'+i;
    return ' ';
}

static int histRange(int pos)
{
    if (pos < 0)
        pos += HISTORY_LINES;
    else if (pos >= HISTORY_LINES)
        pos -= HISTORY_LINES;
    return pos;
}

static s08 * hist_line(int step)
{
    int pos = histRange(ww.histGetPos + step);
    
    while (pos != ww.histGetPos && ww.hist[pos][0]=='\0')
        pos = histRange(pos + step);
    ww.histGetPos = pos;
    return ww.hist[pos];    
}

static void hist_insert(s08 * newLine)
{
    strcpy(ww.hist[ww.histInsPos],newLine);
    ww.histInsPos = histRange(ww.histInsPos+1);
}

void hist_init()
{
    int i;
    
    for (i=0;i<HISTORY_LINES;i++)
        strcpy(ww.hist[i],"");
    ww.histGetPos = ww.histInsPos = 0;
}

/*
 * in scrn - screen pointer
 *    p - absolute point
 */
/*
static int inScreen(pWin w, ScreenPoint p)
{
    / * convert to scrnPoint position * /
    p.r -= w->pos.r-1;
    p.c -= w->pos.c-1;
    return ((p.r >= 0) && (p.r < w->scrn.rsize) &&
            (p.c >= 0) && (p.c < w->scrn.csize));
} */

/*
 * in scrn - screen pointer
 *    p - absolute point
 */
static int in_SCREEN(ScreenPoint p)
{
    /* convert to scrnPoint position */
    return ((p.r >= 0) && (p.r < SCREEN.rsize) &&
            (p.c >= 0) && (p.c < SCREEN.csize));
} 

static void showCursor(pWin w)
{
    ScreenPoint cursor;
    
    cursor.r = w->scrn.cursor.r+w->scrn.area.ul.r-w->viewPos.r+w->pos.r+1;
    cursor.c = w->scrn.cursor.c+w->scrn.area.ul.c-w->viewPos.c+w->pos.c+1;
    if ((w==ww.wList) && w->showCursor && in_SCREEN(cursor))
    {
        _settextposition (cursor.r+1, cursor.c+1);
        if (ww.insertMode)
            scrn_showCursor();
        else
            scrn_showThickCursor();
    }
    else
        scrn_hideCursor();
}        

static void setShowCursor(pWin w, u08 newVal)
{
    w->showCursor = newVal;
    showCursor(w);
}

static void showFrame(pWin w)
{
    if (w!=NULL)
    {
        int r = w->pos.r;
        int c = w->pos.c;
        int active = (w == ww.wList);
        
        scrn_setAttrib(pSCREEN, active ? 
                       ACTIVE_FRAME_ATTRIB : INACTIVE_FRAME_ATTRIB);
        scrn_boxOnlyWithShadow(active ? DOUBLE_LINE : SINGLE_LINE, r, c, 
                               r+w->rsize-1, c+w->csize-1);
        if (w->hotKey || w->name!=NULL)
            scrn_xyPrintf(pSCREEN, r, c+WIN_HEADER_POS,winHeaderFmt,
                          hotKeyCh(w->hotKey), w->name);
        showCursor(w);
    }
}

static int isOnFrame(pWin w, ScreenPoint p, ScreenPtr * ptr)
{
    static ScreenNode n = {0,INACTIVE_FRAME_ATTRIB};
    ScreenPoint lr;
    int col = p.c - w->pos.c;
    
    lr.r = w->pos.r+w->rsize-1;
    lr.c = w->pos.c+w->csize-1;
    if (((p.r == w->pos.r || p.r == lr.r)  && (p.c >= w->pos.c) && (p.c <= lr.c)) ||
        ((p.c == w->pos.c || p.c == lr.c)  && (p.r >= w->pos.r) && (p.r <= lr.r)))
    {
        n.ch = BOXDRAW_HORIZONTAL;  /* assume is horizontal bar */
        if (p.r == w->pos.r)     /* at upper line */
        {
            if (p.c == w->pos.c)  /* at upper left cornor */
                n.ch = BOXDRAW_DOWN_RIGHT;
            else if (p.c == lr.c) /* at upper right cornor */
                n.ch = BOXDRAW_DOWN_LEFT;
            else if ((w->hotKey || w->name!=NULL) && (col>=WIN_HEADER_POS))
            {
                col -= WIN_HEADER_POS;
                if (col == HOTKEY_POS)     /* hot key id */
                    n.ch = hotKeyCh(w->hotKey);
                else if (col < HOTKEY_POS) /* before hotkey id */
                    n.ch = winHeaderFmt[col];
                else if (col < NAME_POS)
                    n.ch = winHeaderFmt[++col];
                else
                {
                    int len = strlen(w->name);
                    col -= NAME_POS;
                    if (col < len)
                        n.ch = w->name[col];
                    else if (col == len)
                        n.ch = ' ';
                }
            }
        }
        else if (p.r == lr.r)    /* at lower line */
        {
            if (p.c == w->pos.c)  /* at lower left cornor */
                n.ch = BOXDRAW_UP_RIGHT;
            else if (p.c == lr.c) /* at lower right cornor */
                n.ch = BOXDRAW_UP_LEFT;
        }
        else                    /* must be either at left or right line */
            n.ch = BOXDRAW_VERTICAL;
        *ptr = &n;
        return 1;
    }
    return 0;
}

static int inWindow(pWin w, ScreenPoint p, scrnPtr * ptr)
{
    if (!isOnFrame(w, p, (ScreenPtr *) ptr))
    {
        ScreenPoint lr;
    
        lr.r = w->pos.r+w->rsize-1;
        lr.c = w->pos.c+w->csize-1;
        if ((p.r < w->pos.r) || (p.r > lr.r) || (p.c < w->pos.c) || (p.c > lr.c))
            return 0;
            
        /* convert to user point of w->scrn */
        p.r = p.r - w->pos.r - w->scrn.area.ul.r - 1;
        p.c = p.c - w->pos.c - w->scrn.area.ul.c - 1;
        *ptr = scrn_scrnPtr(&w->scrn,p);
    }
    return 1;
}

removeFromScreen(pWin w)
{
    pWin temp = w->next;
    ScreenPoint x;
    scrnPtr ptr, sptr;
    int rsize, csize;
    
    for (x.r=w->pos.r, rsize=w->rsize+1; rsize--;x.r++)
    {
        for (x.c=w->pos.c, csize=w->csize+2; csize--;x.c++)
        {
            if (in_SCREEN(x))
            {
                /* x is abs point (user point of pSCREEN) */
                sptr = scrn_scrnPtr(pSCREEN, x);
                temp = w->next;
                while (temp!=NULL)
                {
                    if (inWindow(temp,x,&ptr))
                    {
                        *sptr = *ptr;
                        break;
                    }
                    temp = temp->next;
                }
                if (temp==NULL) /* no window behind */
                {
                    ptr = (scrnPtr) ww.saveScrn + x.r * SCREEN.csize + x.c;
                    *sptr = *ptr;
                }
            }
        }
    }
}

/*
 *  visible - returns screen's position if visible 
 *  p is userPoint
 * 
 */
static ScreenPoint visibleP;
static scrnPtr visiblePtr;
static pWin visibleW;

/*
 * before calling this routine, visibleInit() must be called first 
 * for every block of consequtive call
 */
static scrnPtr visible(int * shadowed)
{   
    scrnPtr retP = visiblePtr;
    pWin w = visibleW;
    int shad_c;
    
    *shadowed = 0;
    /* within screen area? */
    if (in_SCREEN(visibleP))
    {
        /* any window on top? */
        while (w->prev!=NULL)
        {
            w = w->prev;
            if (inWindow(w, visibleP, &retP))
            {
                retP=NULL;
                break;
            }
            if (visibleP.r == w->pos.r+w->rsize)
                *shadowed = 1;
            else 
            {
                shad_c = w->pos.c+w->csize;
                if (visibleP.c == shad_c || visibleP.c == ++shad_c)
                    *shadowed = 1;
            }        
        }
    }
    else
        retP = NULL;
    visiblePtr++;
    visibleP.c++;
    return retP;
}

static void visibleInit(pWin w, ScreenPoint p)
{
    /* convert to screen's user point which is abs point */
    visibleP.r = w->pos.r + p.r + w->scrn.area.ul.r + 1;
    visibleP.c = w->pos.c + p.c + w->scrn.area.ul.c + 1;
    visiblePtr = scrn_scrnPtr(pSCREEN, visibleP);
    visibleW = w;
}

static void win_poll(void)
{
    pWin currW, nextW = ww.wList;
    
    while (nextW!=NULL)
    {
        currW = nextW;
        nextW = currW->next;
        if (currW->func!=NULL)
        {
            util_switch_card(currW->dev);
            switch ((currW->func)(currW,ePOLL,0)) {
            case WIN_ACTION_CLOSE:
                win_close(currW);
                break;
            }
        }
    }
}

//************************************************************************
// public routines
//************************************************************************
/* window functions */
int win_ActivateKey(u16 key)
{
    pWin temp = ww.wList;

    while (temp!=NULL)
    {
        if (temp->hotKey == key)
        {
            win_activate(temp);
            return 1;
        }
        temp = temp->next;
    }
    return 0;
}

void win_partialRefresh(pWin w, int row, int col, int len)
{
    ScreenPoint p;
    scrnPtr bPtr, sPtr;
    int shadowed;

    p.r = row;
    p.c = col;
    
    bPtr = scrn_scrnPtr(&w->scrn,p);
    visibleInit(w,p);
    while (len--)
    {
        if ((sPtr = visible(&shadowed))!=NULL)
        {
            if (shadowed)
                ((ScreenPtr) sPtr)->ch = ((ScreenPtr) bPtr)->ch;
            else
                *sPtr = *bPtr;
        }
        bPtr++;
        p.c++;
    }
}

void win_areaRefresh(pWin w)
{
    int r = w->scrn.area.lr.r - w->scrn.area.ul.r + 1;
    int csize = w->scrn.area.lr.c - w->scrn.area.ul.c + 1;
    
    while (r--)
        win_partialRefresh(w, r, 0, csize);
    showCursor(w);
}

void win_refresh(pWin w)
{
    int r = w->viewPos.r - w->scrn.area.ul.r;
//    int rsize = w->rsize - ((w->type==WIN_NO_FRAME)?0:2);
    int rsize = w->rsize - 2;

    for (;rsize--;r++) 
       win_partialRefresh(w, r, w->viewPos.c - w->scrn.area.ul.c, w->csize-2);
    showFrame(w);
}

/*
void win_setConsole(pWin w, int r1, int c1, int r2, int c2)
{
    scrn_setConsole(w->scrn,r1,c1,r2,c2);
} */

pWin win_new(void * myStruct, u16 hotkey, win_eHandler func, 
             s08 * name, int r, int c, int rsize, int csize,int attrib)
{
    pWin tmp = (pWin) malloc(sizeof(wNode));

    if (tmp!=NULL)
    {
        
        tmp->scrn.buffer = (ScreenPtr) malloc(sizeof(ScreenNode) * (rsize-2) * (csize-2));
//        printf("size=%d,%d malloc_size=%d addr=%p\n",rsize,csize,sizeof(ScreenNode) * (rsize-2) * (csize-2),tmp->scrn.buffer);
//        util_pause(NULL);
        if (tmp->scrn.buffer==NULL)
        {
            free (tmp);
            return NULL;
        }
        tmp->scrn.rsize = rsize-2;
        tmp->scrn.csize = csize-2;
        tmp->scrn.attrib = attrib;

        scrn_setConsole(&tmp->scrn,0,0,tmp->scrn.rsize-1,tmp->scrn.csize-1);
        scrn_clear(&tmp->scrn);
        
        tmp->pos.r = r;
        tmp->viewPos.r = 0;
        tmp->pos.c = c;
        tmp->viewPos.c = 0;
        tmp->rsize = rsize;
        tmp->csize = csize;
        
        tmp->name = name;
        tmp->hotKey = hotkey;
        tmp->func = func;
        tmp->myStruct = myStruct;
//        tmp->type = type;
        tmp->showCursor = 0;
        
        tmp->prev = NULL;
        tmp->next = ww.wList;
        tmp->dev = global.current_card;
        if (ww.wList != NULL)
        {
            ww.wList->prev = tmp;
        }
        else
        {
            if (ww.saveScrn!=NULL)
                free(ww.saveScrn);
            ww.saveScrn = scrn_save();
            ww.oldxy = _gettextposition ();
        }
        ww.wList = tmp;
        showFrame(tmp->next);
        win_refresh(tmp);
    }
    return tmp;
}

pWin win_newBasic(int r, int c, int h, int w, u08 attrib)
{
    return win_new(NULL, 0, NULL, NULL, r, c, h, w, attrib);
}

void win_activate(pWin w)
{
    pWin old= ww.wList;
    
    /* if not already active */
    if (w!=old) 
    {
        w->prev->next = w->next;
        if (w->next!=NULL)
            w->next->prev = w->prev;
        w->next = old;
        w->prev = NULL;
        old->prev = w;
        ww.wList = w;
        showFrame(old);
        win_refresh(w);
    }
}

/*
 * delete w and returns w's next pWin
 */
pWin win_close(pWin w)
{
    pWin temp=NULL;
    
//    util_pause(w->name);
    
    if (w!=NULL)
    {
        if (w->func!=NULL)
        {
            util_switch_card(w->dev);
//            printf("calling addr %p\n",w->func);
//            util_pause(NULL);
            (w->func)(w,eSHUTDOWN,0);
//            printf("return from addr %p\n",w->func);
//            util_pause(NULL);
        }
        removeFromScreen(w);
        temp = w->next;
        if (temp!=NULL)
            temp->prev = w->prev;
        if (w==ww.wList) /* top */
            ww.wList = temp;
        else
            w->prev->next = temp;
/*            
        printf("w=%p, ww.wList=%p, temp=%p\n",w,ww.wList,temp);
        printf("freeing %p, %p\n",w->scrn.buffer,w);
        util_getch();
        {
            int i=40;
            ScreenPtr s = w->scrn.buffer;
            while (i--)
            {
                printf("%c",s->ch);
                s++;
            }
                
              
        }
*/        
        free(w->scrn.buffer);
//        util_pause("freed scrn buffer");
        free(w);
//        util_pause("after free");
    }

//        showWinNames();

    if (ww.wList==NULL)
    {
        if (ww.saveScrn!=NULL)
            scrn_restore(ww.saveScrn);
        free(ww.saveScrn);
        ww.saveScrn = NULL;    
        scrn_showCursor();
        _settextposition (ww.oldxy.row, ww.oldxy.col);
    }
    else
        showFrame(ww.wList);
    return temp;
}

void win_closeAll()
{
    while (ww.wList!=NULL)
        win_close(ww.wList);
    
}

EDIT_t win_editCmdInkey(pWin w, pWEdCmd ed, u16 ch)
{
    int i;
    int r;

    switch (ch) {
    case KEY_RETURN:
        setShowCursor(w,0);
        hist_insert(ed->buff);
        r = w->scrn.cursor.r;
        scrn_writeCh(&w->scrn,'\n',1);
        if (r==w->scrn.cursor.r) /* scroll has occored */
            win_areaRefresh(w);
        return EDIT_GOOD;
        
    case KEY_ESC:
        ed->pos = 0;
        ed->buff[0]='\0';
        break;
        
    case KEY_UP:
        strcpy(ed->buff,hist_line(-1));
        for (ed->pos=0;ed->buff[ed->pos] && (ed->pos < ed->len-1); ed->pos++);
        break;
        
    case KEY_DOWN:
        strcpy(ed->buff,hist_line(1));
        for (ed->pos=0;ed->buff[ed->pos] && (ed->pos < ed->len-1); ed->pos++);
        break;

    case KEY_LEFT:
        if (ed->pos)
            ed->pos--;
        break;
           
    case KEY_RIGHT:
        if (ed->buff[ed->pos] && (ed->pos < ed->len-1))
            ed->pos++;
        break;
        
    case KEY_END:
        while (ed->buff[ed->pos] && (ed->pos < ed->len-1)) 
            ed->pos++;
        break;
    
    case KEY_HOME:
        ed->pos=0;
        break;
        
    case KEY_INSERT:
        ww.insertMode = !ww.insertMode;
        if (ww.insertMode)
            scrn_showCursor();
        else
            scrn_showThickCursor();
        break;
        
    case KEY_BS:
        if (ed->pos)
        {
            for (i=ed->pos-1;ed->buff[i];i++)
                ed->buff[i]=ed->buff[i+1];
            ed->pos--;
        }
        break;

    case KEY_DEL:
        for (i=ed->pos;ed->buff[i];i++)
            ed->buff[i]=ed->buff[i+1];
        break;
        
//    case '?':
//        showWinNames();
//        break;    
        
    default:
        if (ww.insertMode || !ed->buff[ed->pos])
            for (i=ed->len-1;i>ed->pos;i--)
                ed->buff[i]=ed->buff[i-1];
        ed->buff[ed->pos++] = ch;
        if (ed->pos>=ed->len)
            ed->pos--;
        break;
    }
    scrn_xyPrintPad(&w->scrn, ed->origin.r, ed->origin.c,ed->buff,ed->len);
    scrn_gotoxy(&w->scrn, ed->origin.r, ed->origin.c + ed->pos);
    win_partialRefresh(w, ed->origin.r, ed->origin.c, ed->len);
    showCursor(w);
    
    return EDIT_NOACTION;
}

void win_editCmdInit(pWin w, pWEdCmd ed, int r, int c, int len)
{
    pScreen s = &w->scrn;

    setShowCursor(w,1);
    ed->buff[0]='\0';
    ww.histGetPos = ww.histInsPos;
    ed->origin.r = r;
    ed->origin.c = c;
    ed->len = len;
    ed->pos = 0; 
    scrn_xyPrintPad(s, r, c, ed->buff, len);
    scrn_gotoxy(s, r, c);
    win_partialRefresh(w, r, c, len);
    
//    showWinNames();
}

EDIT_t win_editHexInkey(pWin w, pWEdit hex, u16 ch)
{
    int i;
    u08 attrib = 0;

    switch (ch) {
    case KEY_RETURN:
        setShowCursor(w,0);
        return EDIT_GOOD;
        
    case KEY_ESC:
        if (scrn_yes("abort input?"))
        {
            setShowCursor(w,0);
            return EDIT_ABORT;
        }
        break;
        
    case KEY_LEFT:
        if (hex->pos)
            hex->pos--;
        break;
           
    case KEY_RIGHT:
        if (hex->pos<hex->len-1)
            hex->pos++;
        break;
        
    case KEY_END:
        for (hex->pos=hex->len-1; hex->pos && hex->buff[hex->pos]==' '; hex->pos--);
        if (hex->pos!=hex->len-1 && hex->buff[hex->pos]!=' ') 
            hex->pos++;
        break;
    
    case KEY_HOME:
        hex->pos=0;
        break;
        
    case KEY_INSERT:
        ww.insertMode = !ww.insertMode;
        if (ww.insertMode)
            scrn_showCursor();
        else
            scrn_showThickCursor();
        break;
        
    case KEY_BS:
        if (hex->pos)
        {
            for (i=hex->pos-1;i<hex->len-1;i++)
                hex->buff[i]=hex->buff[i+1];
            hex->buff[hex->len-1]=' ';
            hex->pos--;
        }
        break;

    case KEY_DEL:
        for (i=hex->pos;i<hex->len-1;i++)
            hex->buff[i]=hex->buff[i+1];
        hex->buff[hex->len-1]=' ';
        break;
        
    default:
        if (isxdigit(ch) || ch==' ')
        {
            if ((ch!=' ') || hex->spaceAllowed)
            {
                if (!hex->pos && hex->firstKey)
                {
                    for (i=0;i<hex->len;i++)
                        hex->buff[i]=' ';
                }
                if (ww.insertMode)
                    for (i=hex->len-1;i>hex->pos;i--)
                        hex->buff[i]=hex->buff[i-1];
                hex->buff[hex->pos++] = ch;
                if (hex->pos==hex->len)
                    hex->pos--;
                break;
            }
        }
        return EDIT_NOACTION;
    }
    hex->firstKey = 0;
    attrib = scrn_setAttrib(&w->scrn, ATTRIB(BLACK,GRAY));
    scrn_gotoxy(&w->scrn, hex->origin.r, hex->origin.c);
    scrn_print(&w->scrn, hex->buff);
    scrn_gotoxy(&w->scrn, hex->origin.r, hex->origin.c + hex->pos);
    scrn_setAttrib(&w->scrn, attrib);
    win_partialRefresh(w, hex->origin.r, hex->origin.c, hex->len);
    setShowCursor(w,1);
    return EDIT_NOACTION;
}

void win_editHexInit(pWin w, pWEdit hex, int r, int c, int len, int spaceAllowed)
{
    pScreen s = &w->scrn;
    u08 attrib = scrn_setAttrib(s, ATTRIB(BLACK,GRAY));
    
    scrn_xyPrintPad(s, r, c, hex->buff, len);
    scrn_gotoxy(s, r, c);
    setShowCursor(w,1);
    win_partialRefresh(w, r, c, len);
    scrn_setAttrib(s, attrib);
    hex->origin.r = r;
    hex->origin.c = c;
    hex->len = len;
    hex->pos = 0;
    hex->firstKey = 1;
    hex->spaceAllowed = spaceAllowed;
    win_activate(w);
}

EDIT_t win_readHexNumInkey(pWin w, pWHexN hexN, u16 ch)
{
    s08 * str;
    
    EDIT_t ed = win_editHexInkey(w, &hexN->ed, ch);
    if (ed != EDIT_NOACTION)
    {
        if (ed == EDIT_GOOD)
            hexN->data = strtoul(hexN->buffer, &str, 16);
        scrn_setAttrib(&w->scrn, hexN->attrib);
        scrn_xyPrintf(&w->scrn, hexN->ed.origin.r, hexN->ed.origin.c, 
                      hexN->format, hexN->data);
    }
    return ed;
}

void win_readHexNumInit(pWin w, int r, int c, pWHexN hexN, int defData, int len, u08 attrib)
{
    len <<= 1;
    if (len<=8)
    {
        strcpy(hexN->format,"%0");
        sprintf(hexN->buffer,"%dx",len);
        strcat(hexN->format,hexN->buffer);
        sprintf(hexN->buffer,hexN->format,defData);
        hexN->ed.buff = hexN->buffer;
        hexN->attrib = attrib;
        win_editHexInit(w, &hexN->ed, r, c, len, 0);
    }    
}

int win_shutDown()
{
//    util_pause("shutting down the windows");
//    showWinNames();
    win_closeAll();
//    if (ww.saveScrn!=NULL)
//        scrn_restore(ww.saveScrn);
//    free(ww.saveScrn);
//    ww.saveScrn = NULL;    
//    scrn_showCursor();
//    _settextposition (ww.oldxy.row, ww.oldxy.col);
/*
    if (ww.hist!=NULL)
    {
        free(ww.hist);
        ww.hist = NULL;
    }
*/    
    return 0;
}

u16 win_getkey(int wait)
{
    u16 key = 0;
    
    do 
    {
#ifndef EFI
        if (com_isChar())
        {
            key = com_getch();
            break;
        }
        else 
#endif
        if (kbhit())
        {
#ifdef BIOSKEY
            key = _bios_keybrd (_NKEYBRD_READ);
            if ((key & 0xff) == 0xe0)
                key &= 0xff00;
            else if (key & 0xff)
                key &= 0xff;
#else
            key = getch();
            if (!key) 
                key = FUNC_KEY | util_getch();
#endif            
            break;
        }
        win_poll();
    } while (wait); 
    return key;
}

void win_main()
{
    u16 key;
    pWin w;
    while (ww.wList != NULL)
    {
//        showCursor(ww.wList);
        switch((key=win_getkey(1))) {
        case KEY_ALT_F5:
            w = ww.wList;
            /* go to bottom */
            while (w->next!=NULL)
                w = w->next;
            while (w)
            {   
                win_refresh(w);
                w = w->prev;
            }
            break;
            
        case KEY_ALT_F4: 
            win_close(ww.wList);
            break;
            
        case KEY_ALT_F1:
            w = ww.wList;
            /* go to bottom */
            while (w->next!=NULL)
                w = w->next;
            win_activate(w);
            break;
        
        case KEY_ALT_W:
            win_activate(selectWindow());
            break;
            
        default:
            if (!win_ActivateKey(key) && (ww.wList!=NULL))
            {
                /* if it is hotkey, don't bother to send to application */
                if (hotKeyCh(key)==' ')
                {
                    util_switch_card(ww.wList->dev);
                    (ww.wList->func)(ww.wList,eKEY,key);
                }
            } 
//            else
//               showWinNames();
        }
    }
}

/*
void showWinNames()
{
    pWin w;
  
    win_clearscreen();
    for (w=ww.wList; w!=NULL; w = w->next)
        printf("%p, %p name = %s ** \n",w, w->scrn.buffer,w->name);
    util_pause(NULL);
} */

void win_init()
{
    win_closeAll();
}

int win_empty(void)
{
    return ww.wList==NULL;
}

void win_print(s08 * buff)
{
    if (ww.wList!=NULL) 
    {
        scrn_print(&ww.wList->scrn,buff);
        win_areaRefresh(ww.wList);
    }
    else
        _outtext(buff);
}

void win_gotoCol(int x)
{
    if (ww.wList!=NULL)
        scrn_gotoxy(&ww.wList->scrn, ww.wList->scrn.cursor.r, x);
    else
    {
    	struct rccoord old = _gettextposition ();
    	_settextposition (old.row, x+1);
    }
}

void win_wherexy(int * x, int * y)
{
    if (ww.wList!=NULL)
    {
        printf("ww");
        *x = ww.wList->scrn.cursor.r;
        *y = ww.wList->scrn.cursor.c;
    }
    else
    {
    	struct rccoord old = _gettextposition ();
    	*x = old.row - 1;
        *y = old.col - 1;
    }
}

void win_gotoxy(int x,int y)
{
    if (ww.wList!=NULL)
        scrn_gotoxy(&ww.wList->scrn, x, y);
    else
    	_settextposition (x+1, y+1);
}


void win_setTextColor(u08 a)
{
    if (ww.wList!=NULL)
        ww.wList->scrn.attrib = (ww.wList->scrn.attrib & 0xf0) | a;
    else
        _settextcolor(a);
    
}

int win_viewRowSize(void)
{
    if (ww.wList!=NULL)
        return ww.wList->scrn.area.lr.r - ww.wList->scrn.area.ul.r + 1;
    return SCREEN.rsize;
}

s08 * win_gets(void)
{
    wEdCmd_t input;
    
    if (ww.wList!=NULL)
    {
        win_editCmdInit(ww.wList, &input, ww.wList->scrn.cursor.r, 
                        ww.wList->scrn.cursor.c, 39);
        while (win_editCmdInkey(ww.wList, &input, win_getkey(1)) != EDIT_GOOD);
        return input.buff;
    }
    else
    {
        return get_line(NULL);
    }
}

void win_clearscreen()
{
    if (ww.wList!=NULL)
    {
        scrn_clear(&ww.wList->scrn);
        win_areaRefresh(ww.wList);
    }
    else
	    _clearscreen(_GCLEARSCREEN);
}


int  win_select(int r, int c, int width, s08 * title, s08 * selectStr[], u32 * sel, int max)
{
    return 0;
}

#ifndef WIN_CLI
void win_noWinCli(pWin w)
{
    u16 key;
    
    win_refresh(w);
    while (ww.wList!=NULL)
    {
        key = win_getkey(1);
        if (key==KEY_ESC)
            break;
        w->func(w,eKEY,key);
    }
    if (ww.wList!=NULL)
        win_close(w);
}
#endif
