/********************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *  FileName: $Header: /Source/Bcm44xx/b44diag/t_io.h 8     7/19/02 10:07a Ahui $
 *
 *  Description:
 *
 *  AUTHOR: Kevin Tran
 *
 *  $Log: /Source/Bcm44xx/b44diag/t_io.h $
 * 
 * 8     7/19/02 10:07a Ahui
 * Removed unused code
 * 
 * 7     4/25/02 11:03a Ahui
 * 
 * 3     3/07/02 5:05p Ahui
 * Added sromutil support
 *******************************************************************/

#ifndef __T_IO_H__
#define __T_IO_H__

#include "general.h"
#include "eeprom.h"
#include "mm.h"
#include "tigon3.h"

#ifdef EFI
#include <ctype.h>
#endif

#define T3_SRAM_WINB_REG     OFFSETOF(T3_STD_MEM_MAP,PciCfg.MemWindowBaseAddr)
#define T3_SRAM_WINDOW_BASE  OFFSETOF(T3_STD_MEM_MAP,uIntMem.Mbuf[0])
#define T3_SRAM_WINDOW_SIZE  0x8000 /* 32 K bytes */
#define T3_SRAM_WINDOW_MASK  0x7fff

#define T3_REG_BASE_ADDR     OFFSETOF(T3_STD_MEM_MAP,PciCfg.RegBaseAddr)
#define T3_REG_DATA_ADDR     OFFSETOF(T3_STD_MEM_MAP,PciCfg.RegData)
#define T3_SRAM_DATA_REG     OFFSETOF(T3_STD_MEM_MAP,PciCfg.MemWindowData)
/************************************************************************
 *      Functions exported from t_io.c                                 *
 ************************************************************************/
void   t_writemem32 (u16 addr, u32 value);
void   t_writemem16 (u16 addr, u16 value);
void   t_writemem08 (u16 addr, u08 value);
u32    t_readmem32 (u16 addr);
void   t_writemem32b (u16 addr, u32 value);
u16    t_readmem16 (u16 addr);
u08    t_readmem08 (u16 addr);

void   t_writeconf08 (u16 addr, u08 value);
void   t_writeconf16 (u16 addr, u16 value);
void   t_writeconf32 (u16 addr, u32 value);
u08    t_readconf08 (u16 addr);
u16    t_readconf16 (u16 addr);
u32    t_readconf32 (u16 addr);

/************************************************************************
 *      Register offsets, names, and usage				*
 ************************************************************************/

/* Defines bits for registers above that have fields */

/* PCI header section */

/* Misc. Host Control Bit definitions */

/* miscellaneous configuration definitions */

/* PCI state Bit definitions */

/* 
 * DMA State bits 
 */

/*
 * Defines for the MAC TX descriptor 
 */

/*
 * Defines for the MAC RX descriptor 
 */

/* 
 * serdes configuration definitions
 */

/* 
 * CPU state Bit Definitions 
 */

/*
 * MAC Random Bit definitions
 */
#define MAC_TX_RANDOM_MASK                  0x000003ff

/*
 * MAC TX State Bit definitions
 */

/*
 * MAC TX Config Bit definitions
 */

/*
 * MAC TX Length Bit definitions
 */
/*
 * MAC TX Idle Bit definitions
 */
/*
 * MAC RX State Bit definitions
 */

/*
 * Main Event Reg Bit definitions
 */
/*
 * MAC RX Config Bit definitions
 */

/*
 * Timer state Bit definitions
 */

/*
 *	tigon revision definitions
 */
#define UNKNOWN                 0x00

/*
 * serial eeprom revision location
 */


#define BROADCOM_DEVID_4400            0x4400
#define BROADCOM_DEVID_4401            0x4401
#define BROADCOM_DEVID_4402            0x4402
#define BROADCOM_DEVID_FFFF            0xFFFF
#define BROADCOM_DEVID_0000            0x0000
#define BROADCOM_VENDOR_ID  0x14e4



#endif /* __T_IO_H__ */


