/********************************************************************
 * Copyright(c) 2000 Broadcom Corporation, all rights reserved
 * Contains proprietary and confidential information.
 *
 * This source file is the property of Broadcom Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of Broadcom Corporation. 
 *
 *
 *  Name: T Y P E S . H
 *
 *  Description: Generic data type definition
 * 
 *  AUTHOR: Kevin Tran
 *
 *  REVISION HISTORY:   
 *           Kevin Tran   06/01/2000     Created
 *
 *******************************************************************/
#ifndef  __TYPES_H__
#define __TYPES_H__

//#ifdef EFI
//#include "efi_types.h"   /* Define the equivalent types below */
//#else
typedef long int s32;
typedef short s16;
typedef char s8;
typedef char s08;

typedef long int S32;
typedef short S16;
typedef char S8;
typedef char S08;

typedef unsigned long int u32;
typedef unsigned short u16;
typedef unsigned char u8;
typedef unsigned char u08;

typedef unsigned long uint32;
typedef unsigned int uint;
typedef unsigned short uint16;
typedef unsigned char uint8;
typedef unsigned char uchar;
typedef unsigned long ulong;
typedef unsigned long int U32;
typedef unsigned short U16;
typedef unsigned char U8;
typedef unsigned char U08;

typedef unsigned long int ULONG;
typedef unsigned short USHORT;
typedef unsigned char UCHAR;
typedef char CHAR;


typedef unsigned long int uint32;

#if !defined(LP64) && !defined(P64) && !defined(LLP64)
  /* VC 32-bit compiler 5.0 or later */
  #if (_MSC_VER > 800)
    #define P64
  #elif defined(__sun)
    /* Solaris */
    #define LP64
  #elif defined(_HPUX_SOURCE)
    /* HP/UX */
    #define LP64
  #elif defined(__FreeBSD__)
    /* FreeBSD */
    #define LP64
  #elif defined(LINUX)
    /* Linux */
    #define LP64
  #elif defined(__bsdi__)
    /* BSDI */
    #define LP64
  #elif defined(_IRIX)
    #define LP64
  #elif defined(__NETWARE__)
    #define P64
  #endif /* _IRIX */
#endif /* !LP64 && !P64 && !LLP64 */

/*
 * define sized type
 */
#if defined(P64) || defined(LLP64)
  /* P64 */
  typedef unsigned __int64    U64;
  typedef unsigned int        U32;
  typedef unsigned short      U16;
  typedef unsigned char       U8;
  typedef signed __int64      S64;
  typedef signed int          S32;
  typedef signed short        S16;
  typedef signed char         S8;

  typedef unsigned int        u32;
  typedef unsigned short      u16;
  typedef unsigned char       u8;
  typedef unsigned char       u08;
#elif defined(LP64)
  /* LP64: Sun, HP and etc */
  typedef unsigned long long  U64;
  typedef unsigned int        U32;
  typedef unsigned short      U16;
  typedef unsigned char       U8;
  typedef signed long long    S64;
  typedef signed int          S32;
  typedef signed short        S16;
  typedef signed char         S8;
#else 
  /* assume others: 16-bit */
  typedef unsigned char       U64[8];
  typedef unsigned long       U32;
  //typedef unsigned int        U16;
  typedef unsigned char       U8;
  typedef signed char         S64[8];
  typedef signed long         S32;
  typedef signed short        S16;
  //typedef signed char         S8;
#endif /*  */
//#endif

#endif /* __TYPES_H__ */
